### INSTALLATION METHOD
	
- Se cambio la funcion `isModuleAvailable` del archivo `GeneralFunctions.php` para agregar los modulos instalados
 	 Code: 
 	 	function isModuleAvailable($ID)
		{
			global $USER;
			$modules	= explode(';', Config::get()->moduls);
			$iMods 		= Module::get();

			$installed = false;

			foreach ($iMods as $row => $data) {
				if($ID == $data['mod_tag']){
					$installed 		= true;
					$modules[$ID] 	= $data['mod_status'];
				}
			}

			if(!isset($modules[$ID]) && $installed == false)
			{	
				$modules[$ID] = 1;
			}

			return $modules[$ID] == 1 || (isset($USER['authlevel']) && $USER['authlevel'] > AUTH_USR);
		}

- Codigo agregado al template `ModulePage.tpl`
- Contenido agregado a `ShowModulePage.php`
- Agregar al final de `dbtables.php`
 	Code:
 		$dbTableNames['MODULES']= DB_PREFIX.'modules';
- Agregar al archivo `constants.php`
 	Code:
 		if(!defined('MODULES_PATH')) {
			define('MODULES_PATH', ROOT_PATH.'includes/modules/');
		}

- Archivo nuevo `Module.class.php` en la ruta `includes/classes/`
- Agregar al `archivo common.php`
	Code:
		require 'includes/classes/Module.class.php';
- Modificado el codigo de `admin.php`
	Code:
		default:
			if(file_exists('includes/pages/adm/Show'.ucfirst($page).'ModPage.php')){
				include_once('includes/pages/adm/Show'.ucfirst($page).'ModPage.php');
				ShowLoadModPage();
			}
			else{
				include_once('includes/pages/adm/ShowIndexPage.php');
				ShowIndexPage();
			}
		break;


### INSTALACION MEDIANTE ARCHIVO XML

- El sistema de instalacion de modulos tiene una estructura en XML para enviarle algunos datos al servidor asi como las rutas, archivos, y codigo a ejecutar.

`
<installation>
	<mod_data>
		<plugin_tag>bank_mod</plugin_tag>
		<plugin_name>Banco intergalactico</plugin_name>
		<plugin_description>Sistema bancario de recursos para usuarios</plugin_description>
		<developer>Jekill</developer>
		<plugin_link>http://spacewar.nat.cu</plugin_link>
		<version>0.1</version>
	</mod_data>
	<game name="bank_mod">
		<game_page>ShowBankPage.class.php</game_page>
	</game>
	<game_view name="bank_mod">
		<item>page.bank.default.tpl</item>
	</game_view>
	<mod_tag>BANK_TEST_MOD</mod_tag>
	<installation_data>
		<item name="styles/templates/game/main.navigation.tpl">
			<addcode>
				<![CDATA[
					{if isModuleAvailable('mod_bank')}<li><a href="game.php?page=bank">{$LNG.bank}</a></li>{/if}
				]]>
			</addcode>
			<before>
				<![CDATA[
					<li class="menucat2-head"></li>
				]]>
			</before>
			<after>
				<![CDATA[
					{if isModuleAvailable($smarty.const.MODULE_RESSOURCE_LIST)}<li><a href="game.php?page=resources">{$LNG.lm_resources}</a></li>{/if}
				]]>
			</after>
		</item>
	</installation_data>
</installation>
`
- Todo el contenido tiene que estar encapsulado dentro de las etiquetas `<installation>`
- `mod_data` contendra etiquetas para la tabla de modulos
- La etiqueta `game` tiene un atributo `name` que su valor siempre sera el `mod_tag`. Hace referencia a los archivos .php que se subiran a la carpeta `includes/pages/game`. Se subiran tantos archivos como elementos `item` existan.
- game_view es exactamente lo mismo que el anterior solo que esta dirigido a las vistas del juego que se alojaran en la carpeta `styles/templates/(mod_name)/` y de igual manera se subiran tantas .tpl cono `item` existan.
- De igual manera que las 2 anteriores, existen las etiquetas `administration` y `administration_view` que funcionan de la misma forma pero para las carpetas administrativas.
- La etiqueta `mod_tag` que se encuentra debajo de las anteriores, es para generar un bloque cuando se instale codigo desde el sistema de instalacion de modulos. El sistema detecta si es codigo para un archivo .php o .tpl.
- La etiqueta `installation_data` es la mas compleja hasta el momento. Cada `item` dentro de `installation_data` contendra 3 etiquetas: `before`, `after` y `addcode`. Este sistema es para agregar codigo automatico al preexistente. Por ejemplo: el mod que se va a instalar lleva un boton en el menu del jugador. Tomamos el ejemplo del codigo XML de este archivo.

El elemento nuevo tiene que estar entre
	{if isModuleAvailable($smarty.const.MODULE_RESSOURCE_LIST)}<li><a href="game.php?page=resources">{$LNG.lm_resources}</a></li>{/if} y
	<li class="menucat2-head"></li>
Al ser un archivo .tpl el sistema genera lo siguiente

{if isModuleAvailable($smarty.const.MODULE_RESSOURCE_LIST)}<li><a href="game.php?page=resources">{$LNG.lm_resources}</a></li>{/if}
	<!--START BANK_TEST_MOD-->
	{if isModuleAvailable('mod_bank')}<li><a href="game.php?page=bank">{$LNG.bank}</a></li>{/if}
	<!--END BANK_TEST_MOD-->
<li class="menucat2-head"></li>

Con estos mismos codigos se regira el sistema para eliminar el codigo generado si lo que se desea es desinstalar el modulo.

Como ultimo dato: El archivo comprimido para la instalacion solo sera .zip y los archivos dentro de este no tienen orden de carpetas, el orden esta definido en el XML.